searchNodes=[{"doc":"An APIac.Filter plug for API requests rate-limiting This plug uses the Exhammer package as its backend. This library uses the token bucket algorithm, which means that this plug is mainly suitable for limiting abuses, not for accurate rate limiting. By default, a local ETS backend is launched on startup. Plug options key: a (Plug.Conn.t -&gt; String.t | {String.t, non_neg_integer(), non_neg_integer()}) function, taking in parameter the connection and returning either the key, or the tuple {key, scale, limit}. No default value. Note that the APIacFilterThrottler.Functions provides with out-of-the-box functions scale: the time window of the token bucket algorithm, in milliseconds. No default value. limit: the maximum limit of the token bucket algorithm, in attempt count. No default value. increment: the increment of the token bucket algorithm (defaults to 1) backend: Exhammer&#39;s backend, defaults to nil exec_cond: a (Plug.Conn.t() -&gt; boolean()) function that determines whether this filter is to be executed or not. Defaults to fn _ -&gt; true end send_error_response: function called when request is throttled. Defaults to Elixir.APIacFilterThrottler.send_error_response/3 error_response_verbosity: one of :debug, :normal or :minimal. Defaults to :normal Example Allow 50 request / 10 seconds per subject and per client: plug APIacFilterThrottler, key: &amp;APIacFilterThrottler.Functions.throttle_by_subject_client/1, scale: 10_000, limit: 50 Allow 5000 requests / minute per client, only for machine-to-machine access: plug APIacFilterThrottler, key: &amp;APIacFilterThrottler.Functions.throttle_by_client/1, exec_cond: &amp;APIac.machine_to_machine?/1, scale: 60_000, limit: 5000 Security considerations Consider the risk of collisions when constructing the key&gt; For instance, a key function concatenating the ip address and a subject (username) would return the same key (&quot;72.23.241.121edwards&quot;) for: a user &quot;edwards&quot; connecting from 72.23.241.121 a user &quot;1edwards&quot; connecting from 72.23.241.12 The more control an attacker has on choosing the key parameters (e.g. the username), the easier to find a collision. Finding a collision can result in a DOS for the legitimate requester. Using a hash function such as :erlang.phash2/1, MD5, etc. cam help mitigate the risk, at the expense of performance. Also note that :erlang.phash2/1 is not a collision-resistant hash function (as results are not uniformly distributed).","ref":"APIacFilterThrottler.html","title":"APIacFilterThrottler","type":"module"},{"doc":"Implementation of the APIac.Filter behaviour. Verbosity The following elements in the HTTP response are set depending on the value of the :error_response_verbosity option: Error reponse verbosityHTTP statusHeadersBody :debugToo many requests (429)retry-afterAPIac.Filter.Forbidden exception&#39;s message :normalToo many requests (429)retry-after :minimalForbidden (403)","ref":"APIacFilterThrottler.html#send_error_response/3","title":"APIacFilterThrottler.send_error_response/3","type":"function"},{"doc":"Throttling functions that construct keys for the APIacFilterThrottler plug. Note that except throttle_by_ip_subject_client_safe/1, these functions do not protect against collisions. See the Security considerations of the APIacFilterThrottler module for further information.","ref":"APIacFilterThrottler.Functions.html","title":"APIacFilterThrottler.Functions","type":"module"},{"doc":"Returns the authenticated client as a string Make sure that a client is authenticated by an APIac.Authenticator plug, otherwise this function will raise an exception since you certainly don&#39;t want clients to be throttled, but not unauthenticated accesses Example: iex&gt; throttle_by_client(conn) &quot;client32187&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_client/1","title":"APIacFilterThrottler.Functions.throttle_by_client/1","type":"function"},{"doc":"Returns the authenticated client concatenated to the path as a string Make sure that a client is authenticated by an APIac.Authenticator plug, otherwise this function will raise an exception since you certainly don&#39;t want clients to be throttled, but not unauthenticated accesses Example: iex&gt; throttle_by_client_path(conn) &quot;client32187/api/prices/eurusd&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_client_path/1","title":"APIacFilterThrottler.Functions.throttle_by_client_path/1","type":"function"},{"doc":"Returns the IP address as a string Make sure that the remote_ip of the Plug.Conn.t is correctly set Example: iex&gt; throttle_by_ip(conn) &quot;121.42.56.166&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_ip/1","title":"APIacFilterThrottler.Functions.throttle_by_ip/1","type":"function"},{"doc":"Returns the IP address concatenated to client as a string. May be usefull when dealing with OAuth2 public clients such as mobiles apps or SPAs, when many devices share the same client_id and to limit the global volume of calls so as to protect against, for instance, application faults triggering request storms Make sure that the remote_ip of the Plug.Conn.t is correctly set Example: iex&gt; throttle_by_ip_client(conn) &quot;121.42.56.166client10341&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_ip_client/1","title":"APIacFilterThrottler.Functions.throttle_by_ip_client/1","type":"function"},{"doc":"Returns the IP address concatenated to the path as a string Make sure that the remote_ip of the Plug.Conn.t is correctly set Example: iex&gt; throttle_by_ip_path(conn) &quot;121.42.56.166/api/prices/eurusd&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_ip_path/1","title":"APIacFilterThrottler.Functions.throttle_by_ip_path/1","type":"function"},{"doc":"Returns the IP address concatenated to subject and the client. Maybe be usefull when dealing with OAuth2 public clients such as mobiles apps that can be used on several personal devices (e.g. Android laptop, smartphone and tablet) simultaneously (however devices could share the same IP address) Example: iex&gt; throttle_by_ip_subject_client(conn) &quot;275.33.99.208bob23mymobileapp&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_ip_subject_client/1","title":"APIacFilterThrottler.Functions.throttle_by_ip_subject_client/1","type":"function"},{"doc":"Returns the subject concatenated to the client. Maybe be usefull when dealing with OAuth2 public clients such as mobiles apps or SPAs, when many devices share the same client_id, to protect against a malicious user trying to globally block the API Example: iex&gt; throttle_by_subject_client(conn) &quot;bob23mymobileapp&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_subject_client/1","title":"APIacFilterThrottler.Functions.throttle_by_subject_client/1","type":"function"},{"doc":"Same as throttle_by_subject_client/1 but avoids collisions by using :erlang.phash2/1 Example: iex&gt; throttle_by_ip_subject_client_safe(conn) &quot;37541545&quot;","ref":"APIacFilterThrottler.Functions.html#throttle_by_subject_client_safe/1","title":"APIacFilterThrottler.Functions.throttle_by_subject_client_safe/1","type":"function"},{"doc":"APIacFilterThrottler An APIac.Filter plug for API requests rate-limiting This plug uses the Exhammer package as its backend. This library uses the token bucket algorithm, which means that this plug is mainly suitable for limiting abuses, not for accurate rate limiting. By default, a local ETS backend is launched on startup. def deps do [ {:apiac_filter_throttler, &quot;~&gt; 1.0&quot;} ] end","ref":"readme.html","title":"APIacFilterThrottler","type":"extras"},{"doc":"key: a (Plug.Conn.t -&gt; String.t | {String.t, non_neg_integer(), non_neg_integer()}) function, taking in parameter the connection and returning either the key, or the tuple {key, scale, limit}. No default value. Note that the APIacFilterThrottler.Functions provides with out-of-the-box functions scale: the time window of the token bucket algorithm, in milliseconds. No default value. limit: the maximum limit of the token bucket algorithm, in attempt count. No default value. increment: the increment of the token bucket algorithm (defaults to 1) backend: Exhammer&#39;s backend, defaults to nil exec_cond: a (Plug.Conn.t() -&gt; boolean()) function that determines whether this filter is to be executed or not. Defaults to fn _ -&gt; true end send_error_response: function called when request is throttled. Defaults to APIacFilterThrottler.send_error_response/3 error_response_verbosity: one of :debug, :normal or :minimal. Defaults to :normal","ref":"readme.html#plug-options","title":"APIacFilterThrottler - Plug options","type":"extras"},{"doc":"Allow 50 request / 10 seconds per subject and per client: plug APIacFilterThrottler, key: &amp;APIacFilterThrottler.Functions.throttle_by_subject_client/1, scale: 10_000, limit: 50 Allow 5000 requests / minute per client, only for machine-to-machine access: plug APIacFilterThrottler, key: &amp;APIacFilterThrottler.Functions.throttle_by_client/1, exec_cond: &amp;APIac.machine_to_machine?/1, scale: 60_000, limit: 5000","ref":"readme.html#example","title":"APIacFilterThrottler - Example","type":"extras"},{"doc":"Consider the risk of collisions when constructing the key&gt; For instance, a key function concatenating the ip address and a subject (username) would return the same key (&quot;72.23.241.121edwards&quot;) for: a user &quot;edwards&quot; connecting from 72.23.241.121 a user &quot;1edwards&quot; connecting from 72.23.241.12 The more control an attacker has on choosing the key parameters (e.g. the username), the easier to find a collision. Finding a collision can result in a DOS for the legitimate requester. Using a hash function such as :erlang.phash2/1, MD5, etc. cam help mitigate the risk, at the expense of performance. Also note that :erlang.phash2/1 is not a collision-resistant hash function (as results are not uniformly distributed).","ref":"readme.html#security-considerations","title":"APIacFilterThrottler - Security considerations","type":"extras"}]